unit RGPIO;

{
Copyright (C) 2016 - Ronald Daleske

Licence
=======

 LGPLv2.1 with static linking exception (See COPYING.modifiedLGPL.txt)

}

{$mode objfpc}
{$H+}          {Default to AnsiString}
{$inline on}   {Allow use of Inline procedures}



interface

uses
  PReg;


{
Recall that the BCM2835 has 54 GPIOs.
They are controlled by the GPFSEL, GPLEV, GPSET, and GPCLR registers.
}

const
  GPIO0  = 00;
  GPIO1  = 01;
  GPIO2  = 02;
  GPIO3  = 03;
  GPIO4  = 04;
  GPIO5  = 05;
  GPIO6  = 06;
  GPIO7  = 07;
  GPIO8  = 08;
  GPIO9  = 09;
  GPIO10 = 10;
  GPIO11 = 11;
  GPIO12 = 12;
  GPIO13 = 13;
  GPIO14 = 14;
  GPIO15 = 15;
  GPIO16 = 16;
  GPIO17 = 17;
  GPIO18 = 18;
  GPIO19 = 19;
  GPIO20 = 20;
  GPIO21 = 21;
  GPIO22 = 22;
  GPIO23 = 23;
  GPIO24 = 24;
  GPIO25 = 25;
  GPIO26 = 26;
  GPIO27 = 27;
  GPIO28 = 28;
  GPIO29 = 29;
  GPIO30 = 30;
  GPIO31 = 31;
  GPIO32 = 32;
  GPIO33 = 33;
  GPIO34 = 34;
  GPIO35 = 35;
  GPIO36 = 36;
  GPIO37 = 37;
  GPIO38 = 38;
  GPIO39 = 39;
  GPIO40 = 40;
  GPIO41 = 41;
  GPIO42 = 42;
  GPIO43 = 43;
  GPIO44 = 44;
  GPIO45 = 45;
  GPIO46 = 46;
  GPIO47 = 47;
  GPIO48 = 48;
  GPIO49 = 49;
  GPIO50 = 50;
  GPIO51 = 51;
  GPIO52 = 52;
  GPIO53 = 53;



procedure GPIO_OUT_Init(GPIO_pin : LongWord);
procedure GPIO_IN_Init(GPIO_pin : LongWord);



{  ****************  }
{  *** GPIO-Set ***  }
{  ****************  }

procedure GPIO0_Set;
procedure GPIO1_Set;
procedure GPIO2_Set;
procedure GPIO3_Set;
procedure GPIO4_Set;
procedure GPIO5_Set;
procedure GPIO6_Set;
procedure GPIO7_Set;
procedure GPIO8_Set;
procedure GPIO9_Set;
procedure GPIO10_Set;
procedure GPIO11_Set;
procedure GPIO12_Set;
procedure GPIO13_Set;
procedure GPIO14_Set;
procedure GPIO15_Set;
procedure GPIO16_Set;
procedure GPIO17_Set;
procedure GPIO18_Set;
procedure GPIO19_Set;
procedure GPIO20_Set;
procedure GPIO21_Set;
procedure GPIO22_Set;
procedure GPIO23_Set;
procedure GPIO24_Set;
procedure GPIO25_Set;
procedure GPIO26_Set;
procedure GPIO27_Set;
procedure GPIO28_Set;
procedure GPIO29_Set;
procedure GPIO30_Set;
procedure GPIO31_Set;
procedure GPIO32_Set;
procedure GPIO33_Set;
procedure GPIO34_Set;
procedure GPIO35_Set;
procedure GPIO36_Set;
procedure GPIO37_Set;
procedure GPIO38_Set;
procedure GPIO39_Set;
procedure GPIO40_Set;
procedure GPIO41_Set;
procedure GPIO42_Set;
procedure GPIO43_Set;
procedure GPIO44_Set;
procedure GPIO45_Set;
procedure GPIO46_Set;
procedure GPIO47_Set;
procedure GPIO48_Set;
procedure GPIO49_Set;
procedure GPIO50_Set;
procedure GPIO51_Set;
procedure GPIO52_Set;
procedure GPIO53_Set;


{  ******************  }
{  *** GPIO-Clear ***  }
{  ******************  }

procedure GPIO0_Clear;
procedure GPIO1_Clear;
procedure GPIO2_Clear;
procedure GPIO3_Clear;
procedure GPIO4_Clear;
procedure GPIO5_Clear;
procedure GPIO6_Clear;
procedure GPIO7_Clear;
procedure GPIO8_Clear;
procedure GPIO9_Clear;
procedure GPIO10_Clear;
procedure GPIO11_Clear;
procedure GPIO12_Clear;
procedure GPIO13_Clear;
procedure GPIO14_Clear;
procedure GPIO15_Clear;
procedure GPIO16_Clear;
procedure GPIO17_Clear;
procedure GPIO18_Clear;
procedure GPIO19_Clear;
procedure GPIO20_Clear;
procedure GPIO21_Clear;
procedure GPIO22_Clear;
procedure GPIO23_Clear;
procedure GPIO24_Clear;
procedure GPIO25_Clear;
procedure GPIO26_Clear;
procedure GPIO27_Clear;
procedure GPIO28_Clear;
procedure GPIO29_Clear;
procedure GPIO30_Clear;
procedure GPIO31_Clear;
procedure GPIO32_Clear;
procedure GPIO33_Clear;
procedure GPIO34_Clear;
procedure GPIO35_Clear;
procedure GPIO36_Clear;
procedure GPIO37_Clear;
procedure GPIO38_Clear;
procedure GPIO39_Clear;
procedure GPIO40_Clear;
procedure GPIO41_Clear;
procedure GPIO42_Clear;
procedure GPIO43_Clear;
procedure GPIO44_Clear;
procedure GPIO45_Clear;
procedure GPIO46_Clear;
procedure GPIO47_Clear;
procedure GPIO48_Clear;
procedure GPIO49_Clear;
procedure GPIO50_Clear;
procedure GPIO51_Clear;
procedure GPIO52_Clear;
procedure GPIO53_Clear;



{  *****************  }
{  *** GPIO-Read ***  }
{  *****************  }

function GPIO0_Read : Boolean;
function GPIO1_Read : Boolean;
function GPIO2_Read : Boolean;
function GPIO3_Read : Boolean;
function GPIO4_Read : Boolean;
function GPIO5_Read : Boolean;
function GPIO6_Read : Boolean;
function GPIO7_Read : Boolean;
function GPIO8_Read : Boolean;
function GPIO9_Read : Boolean;
function GPIO10_Read : Boolean;
function GPIO11_Read : Boolean;
function GPIO12_Read : Boolean;
function GPIO13_Read : Boolean;
function GPIO14_Read : Boolean;
function GPIO15_Read : Boolean;
function GPIO16_Read : Boolean;
function GPIO17_Read : Boolean;
function GPIO18_Read : Boolean;
function GPIO19_Read : Boolean;
function GPIO20_Read : Boolean;
function GPIO21_Read : Boolean;
function GPIO22_Read : Boolean;
function GPIO23_Read : Boolean;
function GPIO24_Read : Boolean;
function GPIO25_Read : Boolean;
function GPIO26_Read : Boolean;
function GPIO27_Read : Boolean;
function GPIO28_Read : Boolean;
function GPIO29_Read : Boolean;
function GPIO30_Read : Boolean;
function GPIO31_Read : Boolean;
function GPIO32_Read : Boolean;
function GPIO33_Read : Boolean;
function GPIO34_Read : Boolean;
function GPIO35_Read : Boolean;
function GPIO36_Read : Boolean;
function GPIO37_Read : Boolean;
function GPIO38_Read : Boolean;
function GPIO39_Read : Boolean;
function GPIO40_Read : Boolean;
function GPIO41_Read : Boolean;
function GPIO42_Read : Boolean;
function GPIO43_Read : Boolean;
function GPIO44_Read : Boolean;
function GPIO45_Read : Boolean;
function GPIO46_Read : Boolean;
function GPIO47_Read : Boolean;
function GPIO48_Read : Boolean;
function GPIO49_Read : Boolean;
function GPIO50_Read : Boolean;
function GPIO51_Read : Boolean;
function GPIO52_Read : Boolean;
function GPIO53_Read : Boolean;








implementation




{ *************************************** }
{ *******   GPIO Initialization   ******* }
{ *************************************** }


procedure GPIO_OUT_Init(GPIO_pin : LongWord);
var
  value : LongInt;
begin

  {Read current value of GPFSEL}
  case GPIO_pin of
    GPIO0..GPIO9   : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL0);
    GPIO10..GPIO19 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL1);
    GPIO20..GPIO29 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL2);
    GPIO30..GPIO39 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL3);
    GPIO40..GPIO49 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL4);
    GPIO50..GPIO53 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL5);
  end; { case GPIO_pin of }


  case GPIO_pin of

    GPIO0, GPIO10, GPIO20, GPIO30, GPIO40, GPIO50 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111111111111111111000;
        {Include required bits}
        value:=value or  %00000000000000000000000000000001;
      end; { GPIO0 ... }

    GPIO1, GPIO11, GPIO21, GPIO31, GPIO41, GPIO51 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111111111111111000111;
        {Include required bits}
        value:=value or  %00000000000000000000000000001000;
      end; { GPIO1 ... }

    GPIO2, GPIO12, GPIO22, GPIO32, GPIO42, GPIO52 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111111111111000111111;
        {Include required bits}
        value:=value or  %00000000000000000000000001000000;
      end; { GPIO2 ... }

    GPIO3, GPIO13, GPIO23, GPIO33, GPIO43, GPIO53 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111111111000111111111;
        {Include required bits}
        value:=value or  %00000000000000000000001000000000;
      end; { GPIO3 ... }

    GPIO4, GPIO14, GPIO24, GPIO34, GPIO44 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111111000111111111111;
        {Include required bits}
        value:=value or  %00000000000000000001000000000000;
      end; { GPIO4 ... }

    GPIO5, GPIO15, GPIO25, GPIO35, GPIO45 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111111000111111111111111;
        {Include required bits}
        value:=value or  %00000000000000001000000000000000;
      end; { GPIO5 ... }

    GPIO6, GPIO16, GPIO26, GPIO36, GPIO46 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111111000111111111111111111;
        {Include required bits}
        value:=value or  %00000000000001000000000000000000;
      end; { GPIO6 ... }

    GPIO7, GPIO17, GPIO27, GPIO37, GPIO47 :
      begin
        {Mask off relevant bits}
        value:=value and %11111111000111111111111111111111;
        {Include required bits}
        value:=value or  %00000000001000000000000000000000;
      end; { GPIO7 ... }

    GPIO8, GPIO18, GPIO28, GPIO38, GPIO48 :
      begin
        {Mask off relevant bits}
        value:=value and %11111000111111111111111111111111;
        {Include required bits}
        value:=value or  %00000001000000000000000000000000;
      end; { GPIO8 ... }

    GPIO9, GPIO19, GPIO29, GPIO39, GPIO49 :
      begin
        {Mask off relevant bits}
        value:=value and %11000111111111111111111111111111;
        {Include required bits}
        value:=value or  %00001000000000000000000000000000;
      end; { GPIO9 ... }

  end; { case GPIO_pin of }


  {Write new value to GPFSEL}
  case GPIO_pin of
    GPIO0..GPIO9   : PREG_Write(GPIO_BASE+GPIO_GPFSEL0,value);
    GPIO10..GPIO19 : PREG_Write(GPIO_BASE+GPIO_GPFSEL1,value);
    GPIO20..GPIO29 : PREG_Write(GPIO_BASE+GPIO_GPFSEL2,value);
    GPIO30..GPIO39 : PREG_Write(GPIO_BASE+GPIO_GPFSEL3,value);
    GPIO40..GPIO49 : PREG_Write(GPIO_BASE+GPIO_GPFSEL4,value);
    GPIO50..GPIO53 : PREG_Write(GPIO_BASE+GPIO_GPFSEL5,value);
  end; { case GPIO_pin of }


end; { procedure GPIO_OUT_Init }





procedure GPIO_IN_Init(GPIO_pin : LongWord);
var
  value : LongInt;
begin

  {Read current value of GPFSEL}
  case GPIO_pin of
    GPIO0..GPIO9   : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL0);
    GPIO10..GPIO19 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL1);
    GPIO20..GPIO29 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL2);
    GPIO30..GPIO39 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL3);
    GPIO40..GPIO49 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL4);
    GPIO50..GPIO53 : value:=PREG_Read(GPIO_BASE+GPIO_GPFSEL5);
  end; { case GPIO_pin of }

  {Mask off relevant bits}
  case GPIO_pin of

    GPIO0, GPIO10, GPIO20, GPIO30, GPIO40, GPIO50 :
      value:=value and %11111111111111111111111111111000;

    GPIO1, GPIO11, GPIO21, GPIO31, GPIO41, GPIO51 :
      value:=value and %11111111111111111111111111000111;

    GPIO2, GPIO12, GPIO22, GPIO32, GPIO42, GPIO52 :
      value:=value and %11111111111111111111111000111111;

    GPIO3, GPIO13, GPIO23, GPIO33, GPIO43, GPIO53 :
      value:=value and %11111111111111111111000111111111;

    GPIO4, GPIO14, GPIO24, GPIO34, GPIO44 :
      value:=value and %11111111111111111000111111111111;

    GPIO5, GPIO15, GPIO25, GPIO35, GPIO45 :
      value:=value and %11111111111111000111111111111111;

    GPIO6, GPIO16, GPIO26, GPIO36, GPIO46 :
      value:=value and %11111111111000111111111111111111;

    GPIO7, GPIO17, GPIO27, GPIO37, GPIO47 :
      value:=value and %11111111000111111111111111111111;

    GPIO8, GPIO18, GPIO28, GPIO38, GPIO48 :
      value:=value and %11111000111111111111111111111111;

    GPIO9, GPIO19, GPIO29, GPIO39, GPIO49 :
      value:=value and %11000111111111111111111111111111;

  end; { case GPIO_pin of }


  {Write new value to GPFSEL}
  case GPIO_pin of
    GPIO0..GPIO9   : PREG_Write(GPIO_BASE+GPIO_GPFSEL0,value);
    GPIO10..GPIO19 : PREG_Write(GPIO_BASE+GPIO_GPFSEL1,value);
    GPIO20..GPIO29 : PREG_Write(GPIO_BASE+GPIO_GPFSEL2,value);
    GPIO30..GPIO39 : PREG_Write(GPIO_BASE+GPIO_GPFSEL3,value);
    GPIO40..GPIO49 : PREG_Write(GPIO_BASE+GPIO_GPFSEL4,value);
    GPIO50..GPIO53 : PREG_Write(GPIO_BASE+GPIO_GPFSEL5,value);
  end; { case GPIO_pin of }


end; { procedure GPIO_IN_Init }



{  ****************  }
{  *** GPIO-Set ***  }
{  ****************  }


procedure GPIO0_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_0);
end; { procedure GPIO0_Set }



procedure GPIO1_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_1);
end; { procedure GPIO1_Set }


procedure GPIO2_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_2);
end; { procedure GPIO2_Set }


procedure GPIO3_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_3);
end; { procedure GPIO3_Set }


procedure GPIO4_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_4);
end; { procedure GPIO4_Set }


procedure GPIO5_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_5);
end; { procedure GPIO5_Set }


procedure GPIO6_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_6);
end; { procedure GPIO6_Set }


procedure GPIO7_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_7);
end; { procedure GPIO6_Set }


procedure GPIO8_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_8);
end; { procedure GPIO8_Set }


procedure GPIO9_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_9);
end; { procedure GPIO9_Set }


procedure GPIO10_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_10);
end; { procedure GPIO10_Set }


procedure GPIO11_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_11);
end; { procedure GPIO11_Set }


procedure GPIO12_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_12);
end; { procedure GPIO12_Set }


procedure GPIO13_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_13);
end; { procedure GPIO13_Set }


procedure GPIO14_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_14);
end; { procedure GPIO14_Set }


procedure GPIO15_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_15);
end; { procedure GPIO15_Set }


procedure GPIO16_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_16);
end; { procedure GPIO16_Set }


procedure GPIO17_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_17);
end; { procedure GPIO17_Set }


procedure GPIO18_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_18);
end; { procedure GPIO18_Set }


procedure GPIO19_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_19);
end; { procedure GPIO19_Set }


procedure GPIO20_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_20);
end; { procedure GPIO20_Set }


procedure GPIO21_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_21);
end; { procedure GPIO21_Set }


procedure GPIO22_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_22);
end; { procedure GPIO22_Set }


procedure GPIO23_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_23);
end; { procedure GPIO23_Set }


procedure GPIO24_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_24);
end; { procedure GPIO24_Set }


procedure GPIO25_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_25);
end; { procedure GPIO25_Set }


procedure GPIO26_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_26);
end; { procedure GPIO26_Set }


procedure GPIO27_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_27);
end; { procedure GPIO27_Set }


procedure GPIO28_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_28);
end; { procedure GPIO28_Set }


procedure GPIO29_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_29);
end; { procedure GPIO29_Set }


procedure GPIO30_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_30);
end; { procedure GPIO30_Set }


procedure GPIO31_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET0,MASK_GPIO_31);
end; { procedure GPIO31_Set }


procedure GPIO32_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_32);
end; { procedure GPIO32_Set }


procedure GPIO33_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_33);
end; { procedure GPIO33_Set }


procedure GPIO34_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_34);
end; { procedure GPIO34_Set }


procedure GPIO35_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_35);
end; { procedure GPIO35_Set }


procedure GPIO36_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_36);
end; { procedure GPIO36_Set }


procedure GPIO37_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_37);
end; { procedure GPIO37_Set }


procedure GPIO38_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_38);
end; { procedure GPIO38_Set }


procedure GPIO39_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_39);
end; { procedure GPIO39_Set }


procedure GPIO40_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_40);
end; { procedure GPIO40_Set }


procedure GPIO41_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_41);
end; { procedure GPIO41_Set }


procedure GPIO42_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_42);
end; { procedure GPIO40_Set }


procedure GPIO43_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_43);
end; { procedure GPIO43_Set }


procedure GPIO44_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_44);
end; { procedure GPIO44_Set }


procedure GPIO45_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_45);
end; { procedure GPIO45_Set }


procedure GPIO46_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_46);
end; { procedure GPIO46_Set }


procedure GPIO47_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_47);
end; { procedure GPIO47_Set }


procedure GPIO48_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_48);
end; { procedure GPIO48_Set }


procedure GPIO49_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_49);
end; { procedure GPIO49_Set }


procedure GPIO50_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_50);
end; { procedure GPIO50_Set }


procedure GPIO51_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_51);
end; { procedure GPIO51_Set }


procedure GPIO52_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_52);
end; { procedure GPIO52_Set }


procedure GPIO53_Set;
begin
  PREG_Write(GPIO_BASE+GPIO_GPSET1,MASK_GPIO_53);
end; { procedure GPIO53_Set }






{  ******************  }
{  *** GPIO-Clear ***  }
{  ******************  }



procedure GPIO0_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_0);
end; { procedure GPIO0_Clear }


procedure GPIO1_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_1);
end; { procedure GPIO1_Clear }


procedure GPIO2_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_2);
end; { procedure GPIO2_Clear }


procedure GPIO3_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_3);
end; { procedure GPIO3_Clear }


procedure GPIO4_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_4);
end; { procedure GPIO4_Clear }


procedure GPIO5_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_5);
end; { procedure GPIO5_Clear }


procedure GPIO6_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_6);
end; { procedure GPIO6_Clear }


procedure GPIO7_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_7);
end; { procedure GPIO7_Clear }


procedure GPIO8_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_8);
end; { procedure GPIO8_Clear }


procedure GPIO9_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_9);
end; { procedure GPIO9_Clear }


procedure GPIO10_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_10);
end; { procedure GPIO10_Clear }


procedure GPIO11_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_11);
end; { procedure GPIO11_Clear }


procedure GPIO12_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_12);
end; { procedure GPIO12_Clear }


procedure GPIO13_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_13);
end; { procedure GPIO13_Clear }


procedure GPIO14_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_14);
end; { procedure GPIO14_Clear }


procedure GPIO15_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_15);
end; { procedure GPIO15_Clear }


procedure GPIO16_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_16);
end; { procedure GPIO16_Clear }


procedure GPIO17_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_17);
end; { procedure GPIO17_Clear }


procedure GPIO18_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_18);
end; { procedure GPIO18_Clear }


procedure GPIO19_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_19);
end; { procedure GPIO19_Clear }


procedure GPIO20_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_20);
end; { procedure GPIO20_Clear }


procedure GPIO21_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_21);
end; { procedure GPIO21_Clear }


procedure GPIO22_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_22);
end; { procedure GPIO22_Clear }


procedure GPIO23_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_23);
end; { procedure GPIO23_Clear }


procedure GPIO24_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_24);
end; { procedure GPIO24_Clear }


procedure GPIO25_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_25);
end; { procedure GPIO25_Clear }


procedure GPIO26_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_26);
end; { procedure GPIO26_Clear }


procedure GPIO27_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_27);
end; { procedure GPIO27_Clear }


procedure GPIO28_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_28);
end; { procedure GPIO28_Clear }


procedure GPIO29_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_29);
end; { procedure GPIO29_Clear }


procedure GPIO30_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_30);
end; { procedure GPIO30_Clear }


procedure GPIO31_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR0,MASK_GPIO_31);
end; { procedure GPIO31_Clear }


procedure GPIO32_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_32);
end; { procedure GPIO32_Clear }


procedure GPIO33_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_33);
end; { procedure GPIO33_Clear }


procedure GPIO34_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_34);
end; { procedure GPIO34_Clear }


procedure GPIO35_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_35);
end; { procedure GPIO35_Clear }


procedure GPIO36_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_36);
end; { procedure GPIO36_Clear }


procedure GPIO37_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_37);
end; { procedure GPIO37_Clear }


procedure GPIO38_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_38);
end; { procedure GPIO38_Clear }


procedure GPIO39_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_39);
end; { procedure GPIO39_Clear }


procedure GPIO40_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_40);
end; { procedure GPIO40_Clear }


procedure GPIO41_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_41);
end; { procedure GPIO41_Clear }


procedure GPIO42_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_42);
end; { procedure GPIO42_Clear }


procedure GPIO43_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_43);
end; { procedure GPIO43_Clear }


procedure GPIO44_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_44);
end; { procedure GPIO44_Clear }


procedure GPIO45_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_45);
end; { procedure GPIO45_Clear }


procedure GPIO46_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_46);
end; { procedure GPIO46_Clear }


procedure GPIO47_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_47);
end; { procedure GPIO47_Clear }


procedure GPIO48_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_48);
end; { procedure GPIO48_Clear }


procedure GPIO49_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_49);
end; { procedure GPIO49_Clear }


procedure GPIO50_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_50);
end; { procedure GPIO50_Clear }


procedure GPIO51_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_51);
end; { procedure GPIO51_Clear }


procedure GPIO52_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_52);
end; { procedure GPIO52_Clear }


procedure GPIO53_Clear;
begin
  PREG_Write(GPIO_BASE+GPIO_GPCLR1,MASK_GPIO_53);
end; { procedure GPIO53_Clear }





{  *****************  }
{  *** GPIO-Read ***  }
{  *****************  }



function GPIO0_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_0)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO0_Read }



function GPIO1_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_1)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO1_Read }



function GPIO2_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_2)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO2_Read }



function GPIO3_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_3)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO3_Read }



function GPIO4_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_4)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO4_Read }



function GPIO5_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_5)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO5_Read }



function GPIO6_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_6)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO6_Read }



function GPIO7_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_7)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO7_Read }



function GPIO8_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_8)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO8_Read }



function GPIO9_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_9)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO9_Read }



function GPIO10_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_10)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO10_Read }



function GPIO11_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_11)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO11_Read }



function GPIO12_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_12)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO12_Read }



function GPIO13_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_13)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO13_Read }



function GPIO14_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_14)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO14_Read }



function GPIO15_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_15)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO15_Read }



function GPIO16_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_16)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO16_Read }



function GPIO17_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_17)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO17_Read }



function GPIO18_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_18)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO18_Read }



function GPIO19_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_19)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO19_Read }



function GPIO20_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_20)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO20_Read }



function GPIO21_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_21)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO21_Read }



function GPIO22_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_22)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO22_Read }



function GPIO23_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_23)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO23_Read }



function GPIO24_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_24)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO24_Read }



function GPIO25_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_25)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO25_Read }



function GPIO26_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_26)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO26_Read }



function GPIO27_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_27)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO27_Read }



function GPIO28_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_28)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO28_Read }



function GPIO29_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_29)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO29_Read }



function GPIO30_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_30)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO30_Read }



function GPIO31_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV0);

  if ((GP_Read and MASK_GPIO_31)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO31_Read }



function GPIO32_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_32)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO32_Read }


function GPIO33_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_33)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO33_Read }



function GPIO34_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_34)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO34_Read }



function GPIO35_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_35)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO35_Read }



function GPIO36_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_36)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO36_Read }



function GPIO37_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_37)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO37_Read }



function GPIO38_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_38)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO38_Read }



function GPIO39_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_39)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO39_Read }



function GPIO40_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_40)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO40_Read }


function GPIO41_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_41)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO41_Read }



function GPIO42_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_42)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO42_Read }



function GPIO43_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_43)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO43_Read }



function GPIO44_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_44)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO44_Read }



function GPIO45_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_45)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO45_Read }



function GPIO46_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_46)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO46_Read }



function GPIO47_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_47)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO47_Read }



function GPIO48_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_48)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO48_Read }



function GPIO49_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_49)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO49_Read }



function GPIO50_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_50)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO50_Read }


function GPIO51_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_51)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO51_Read }



function GPIO52_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_52)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO52_Read }



function GPIO53_Read : Boolean;
var
  GP_Read : LongWord;
begin
  GP_Read:=PREG_Read(GPIO_BASE+GPIO_GPLEV1);

  if ((GP_Read and MASK_GPIO_53)=0) then
    Result:=false
  else
    Result:=true;

end; { function GPIO53_Read }





end.

